#!/bin/bash

CWD=$(dirname $0)
ROUTER_IP=$(bash "$CWD/general/get_router_ip.sh")
URL_PREFIX="http://$ROUTER_IP"
login_page=$(curl -Ls "$URL_PREFIX")

#get_token(){
#	token=$(cat cookie.txt | grep sessionToken | awk '{print $7}')
#	rm cookie.txt
#}

# If noscript-page is avaiable, then navigate there.
noscript=$(echo ${login_page} | grep "<noscript>")
if [ -n "$noscript" ]
then
    noscript_urlsuffix=$(echo $noscript | \
        awk -F'url=' '{print $2}' | \
        awk -F'"' '{print $1}')
    login_page=$(curl -sL "$URL_PREFIX/$noscript_urlsuffix")
fi

# Which vendor keyword is present on the login page.
if [ -n "$(echo $login_page | grep Turris)" ]
then
    echo Turris > router.txt
elif [ -n "$(echo $login_page | grep EasyBox)" ]
then
    echo Easybox > router.txt
elif [ -n "$(echo $login_page | grep -F 'FRITZ!Box')" ]
then
    #echo Fritzbox
    KEY="j:Name"
    xml_out=$(curl -s "http://${ROUTER_IP}/jason_boxinfo.xml")
    echo $(echo $xml_out | \
        awk -F"<$KEY>" '{print $2}' | \
        awk -F"<" '{print $1}') > router.txt
elif [ -n "$(echo $login_page | grep Speedport)" ]
then
    echo Speedport > router.txt
elif [ -n "$(echo $login_page | grep 'Compal Broadband Networks')" ]
then
    echo Compal > router.txt
    #curl -s \
    #	-H "Host: $ROUTER_IP" \
    #	-H "Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8" \
    #	-H "Accept-Language: en-US,en;q=0.5" \
    #	-H "Accept-Encoding: gzip, deflate" \
    #	-H "DNT: 1" \
    #	-H "Connection: keep-alive" \
    #	-H "Upgrade-Insecure-Requests: 1" \
    #	-c "cookie.txt" \
    #	"http://$ROUTER_IP/" > /dev/null
    #get_token
    #login_data="token=$token&fun=15&Username=admin&Password=$PASSWORD"
    #login_resp=$(curl -s \
    #	-H "Host: $ROUTER_IP" \
    #	-H "Accept: text/plain, */*; q=0.01" \
    #	-H "Accept-Language: en-US,en;q=0.5" \
    #	-H "Accept-Encoding: gzip, deflate" \
    #	-H "Referer: http://$ROUTER_IP/common_page/login.html" \
    #	-H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
    #	-H "X-Requested-With: XMLHttpRequest" \
    #	-H "DNT: 1" \
    #	-H "Connection: keep-alive" \
    #	-H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
    #	-c "cookie.txt" \
    #	-d "$login_data" \
    #	"http://$ROUTER_IP/xml/setter.xml") > /dev/null
    #get_token
    #data="token=$token&fun=1"
    #get_resp=$(curl -s \
    #	-H "Host: $ROUTER_IP" \
    #	-H "Accept: application/xml, text/xml, */*; q=0.01" \
    #	-H "Accept-Language: en-US,en;q=0.5" \
    #	-H "Accept-Encoding: gzip, deflate" \
    #	-H "Referer: http://$ROUTER_IP/wifi_page/wlanRadio.html" \
    #	-H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
    #	-H "X-Requested-With: XMLHttpRequest" \
    #	-H "DNT: 1" \
    #	-H "Connection: keep-alive" \
    #	-H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
    #	-c "cookie.txt" \
    #	-d "$data" \
    #    "http://$ROUTER_IP/xml/getter.xml")
    #router_model=$(echo $get_resp | \
    #    awk -F'<SwVersion>' '{print $2}' | \
    #    awk -F'-' '{print $1}')
    #echo $router_model
    #get_token
    #data="token=$token&fun=1"
    #curl -s \
    #    -H "Host: $ROUTER_IP" \
    #    -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
    #    -H "Accept: application/xml, text/xml, */*; q=0.01" \
    #    -H "Accept-Language: en-US,en;q=0.5" \
    #    -H "Accept-Encoding: gzip, deflate" \
    #    -H "Referer: http://$ROUTER_IP/index.html" \
    #    -H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
    #    -H "X-Requested-With: XMLHttpRequest" \
    #    -H "DNT: 1" \
    #    -H "Connection: keep-alive" \
    #    -H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=3317885440" \
    #    -c "cookie.txt" \
    #    -d "$data" \
    #    "http://$ROUTER_IP/xml/getter.xml"
    #get_token
    #data="token=$token&fun=16"
    #curl -s \
    #    -H "Host: $ROUTER_IP" \
    #    -H "User-Agent: Mozilla/5.0 (X11; Ubuntu; Linux x86_64; rv:64.0) Gecko/20100101 Firefox/64.0" \
    #    -H "Accept: text/plain, */*; q=0.01" \
    #    -H "Accept-Language: en-US,en;q=0.5" \
    #    -H "Accept-Encoding: gzip, deflate" \
    #    -H "Referer: http://$ROUTER_IP/index.html" \
    #    -H "Content-Type: application/x-www-form-urlencoded; charset=UTF-8" \
    #    -H "X-Requested-With: XMLHttpRequest" \
    #    -H "DNT: 1" \
    #    -H "Connection: keep-alive" \
    #    -H "Cookie: prefIdiom=images/de.gif*German*de; sessionToken=$token" \
    #    -d "$data" \
    #    -c "cookie.txt" \
    #    "http://$ROUTER_IP/xml/setter.xml" > /dev/null
    #get_token
else
    echo $login_page
    echo "Your router model is not supported."
    exit 1
fi
