#!/bin/ash

###
### ROUTER VENDOR IDENTIFICATION SCRIPT
###

CWD=$(dirname $0)
ROUTER_IP=$(ash "$CWD/general/get_router_ip.sh")

while getopts p:udc opt
do
	case $opt in
		p) PASSWORD=$OPTARG;;
		d) OPTION="-d";;
		u) OPTION="-u";;
		c) OPTION="-c";;
	esac
done

URL_PREFIX="http://${ROUTER_IP}"

login_page=$(curl -Ls "${URL_PREFIX}")

# If noscript-page is available, then navigate there.
noscript=$(echo ${login_page} | grep "<noscript>")
if [ -n "$noscript" ]; then
	noscript_urlsuffix=$(echo $noscript | awk -F'url=' '{print $2}' | awk -F'"' '{print $1}')
	login_page=$(curl -sL "$URL_PREFIX/$noscript_urlsuffix")
fi

# Which vendor keyword is present on the login page
if [ -n "$(echo $login_page | grep EasyBox)" ]; then
	#echo "Hi, I am an EasyBox!"
	ash $CWD/easybox/804.sh -r $ROUTER_IP -p $PASSWORD $OPTION
elif [ -n "$(echo $login_page | grep Speedport)" ]; then
	#echo "Hi, I am a Speedport!"
	MODEL=$(bash $CWD/speedport/identify_model.sh $ROUTER_IP -m)
	if [ "$MODEL" == "Speedport Smart" ]; then
		echo "Speedport Smart" > router.txt
		ash $CWD/speedport/smart.sh -r $ROUTER_IP -p $PASSWORD $OPTION
	elif [ "$MODEL" == "Speedport W 724V" ]; then
		echo "Speedport W 724V" > router.txt
		ash $CWD/speedport/w724v_A.sh -r $ROUTER_IP -p $PASSWORD $OPTION
	fi
elif [ -n "$(echo $login_page | grep -F 'FRITZ!Box')" ]; then

	CWD=$(dirname $0)
	KEY="j:Name"

	xml_out=$(curl -s "http://${ROUTER_IP}/jason_boxinfo.xml")
	echo $(echo $xml_out | awk -F"<$KEY>" '{print $2}' | awk -F"<" '{print $1}') > router.txt

	if [ -n "$PASSWORD" ]; then
		if [ -n "$OPTION" ]; then
			ash $CWD/fritzbox/test_interface.sh -r $ROUTER_IP -p $PASSWORD $OPTION
		else
			ash $CWD/fritzbox/test_interface.sh -r $ROUTER_IP -p $PASSWORD
		fi
	else
		if [ -n "$OPTION" ]; then
			ash $CWD/fritzbox/test_interface.sh -r $ROUTER_IP $OPTION
		else
			ash $CWD/fritzbox/test_interface.sh -r $ROUTER_IP
		fi
	fi
fi

exit 0;
